#!/bin/bash
# $1 is the job to run

# In case *_JOB_DIR are relative paths...
basedir=$(pwd)

cd $RUNNING_JOB_DIR/$1/

script="$(cut -d$'\n' -f1 config)"
startCommit="$(cut -d$'\n' -f2 config)"
startCommit=${startCommit#r}
endCommit="$(cut -d$'\n' -f3 config)"
endCommit=${endCommit#r}

echo "Starting revision setup"

currentCommit=${startCommit}
svn co https://svn.code.sf.net/p/brlcad/code/brlcad/trunk brlcad -r "$startCommit"
cd brlcad/
while ((currentCommit<=endCommit)); do
    mkdir -p ../output/r$currentCommit
    ../$script > ../output/r$currentCommit/stdout.log 2>../output/r$currentCommit/stderr.log
    echo "$?" > ../output/r$currentCommit/returncode.log
    echo "$currentCommit" > ../currentCommit
    svn up -r "$((++currentCommit))"
    while [[ $(cat ../state) == pause* ]]; do
        if [[ $(cat ../state) == pauseRequested ]]; then
            echo "paused" > ../state
        fi
        sleep 5s;
    done
    if [[ $(cat ../state) == resumeRequested ]]; then
        # This uses -gt in the comparison because on of the running
        # jobs is this (resumeRequested, not paused) job.  Making resumeRequested jobs be considered running is good, because it stops jobScheduler.sh from filling their spots with other jobs.
        while [[ $(cd $basedir; ./getRunningJobs.sh) -gt $MAX_RUNNING_JOBS ]]; do
            sleep 5s;
        done
        echo "running" > ../state
    fi
done

cd $basedir
mv $RUNNING_JOB_DIR/$1 $COMPLETED_JOB_DIR/$1
echo "completed" > $RUNNING_JOB_DIR/$job/state
rm -r $COMPLETED_JOB_DIR/$1/brlcad
